//----------------------------------------------------------------------------
// ObjectWindows - (C) Copyright 1991, 1993 by Borland International
//----------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\dialog.h>
#include <owl\dc.h>
#include <stdio.h>
#include <owl\owlpch.h>
#include <owl\dialog.h>
#include <mmsystem.h>
#include <windowsx.h>

char  AppName[]  = "ScreenSaver.KillBarney!";
char Animationa[5];
int Animationi;
char Sounda[5];
int Soundi;
POINT Holes[35] = {
  { 100, 10 }, { 300, 10 }, { 200, 100 }, { 100, 200 }, { 300, 200 },
  {100,100},{300,100},{200,10},{10,10},{10,100},{10,200},{10,300},
  {390,10},{390,90},{390,200},{390,300},{10,400},{100,300},{100,400},
  {200,200},{200,300},{200,400},{300, 300},{300,400},{390,400},{480,10},
  {480,100},{480,200},{480,300},{480,400},{570,10},{570,100},{570,200},
  {570,300},{570,400}
};

struct THole {
	int alive;
	int livetme;
	int deadtme;
};
THole       HoleInfo[35];
int Numholes = 35;
class TScrnSavWindow : public TFrameWindow {
  public:
	 TScrnSavWindow(TWindow* parent, const char* title, TModule* = 0);
	 ~TScrnSavWindow();

	 // Our own screen saver virtual
	 //
	 virtual void AnimateScreen() {}

  protected:

	 // Override TWindow virtuals
	 //
	 char far* GetClassName() {return "OWLScreenSaverClass";}
	 void GetWindowClass(WNDCLASS& wndClass);
	 void SetupWindow();

	 // Event handlers
	 //
	 void EvMouseMove(UINT, TPoint&);
	 void EvLButtonDown(UINT, TPoint&);
	 void EvRButtonDown(UINT, TPoint&);
	 void EvMButtonDown(UINT, TPoint&);
	 void EvActivate(UINT, BOOL, HWND);
	 #if defined(__WIN32__)
		void EvActivateApp(BOOL, HANDLE);
	 #else
		void EvActivateApp(BOOL, HTASK);
	 #endif
	 void EvKeyDown(UINT, UINT, UINT);
	 void EvSysKeyDown(UINT, UINT, UINT);
	 void EvSysCommand(UINT, TPoint&);

  private:
	 TPoint   PrevPt;

  DECLARE_RESPONSE_TABLE(TScrnSavWindow);
};

class TScrnSavApp : public TApplication {
  public:
	 TScrnSavApp(char far* name) : TApplication(name), ScrnSavWnd(0),
											 ConfigureDialog(0) {}

	 int  Run();

  protected:
	 BOOL            Configuring;
	 TDialog*        ConfigureDialog;
	 TScrnSavWindow* ScrnSavWnd;

	 void InitMainWindow();
	 BOOL IdleAction(long);

	 //
	 // Virtual functions for screen save apps
	 //
	 virtual void InitScrnSavWindow();
	 virtual void InitConfigDialog() {}

  private:
	 uint32   LastTime;
};

DEFINE_RESPONSE_TABLE1(TScrnSavWindow, TFrameWindow)
  EV_WM_MOUSEMOVE,
  EV_WM_LBUTTONDOWN,
  EV_WM_RBUTTONDOWN,
  EV_WM_MBUTTONDOWN,
  EV_WM_ACTIVATE,
  EV_WM_ACTIVATEAPP,
  EV_WM_KEYDOWN,
  EV_WM_SYSKEYDOWN,
  EV_WM_SYSCOMMAND,
END_RESPONSE_TABLE;

TScrnSavWindow::TScrnSavWindow(TWindow* parent, const char* title, TModule* module)
  : TFrameWindow(parent, title, 0, FALSE, module)
{
  ShowCursor(FALSE);
  Attr.Style = WS_POPUP;
}

TScrnSavWindow::~TScrnSavWindow()
{
  ShowCursor(TRUE);
}

void
TScrnSavWindow::GetWindowClass(WNDCLASS& wndClass)
{
  TWindow::GetWindowClass(wndClass);
  wndClass.hIcon = 0;
  wndClass.style |= CS_SAVEBITS;
  wndClass.hbrBackground = (HBRUSH)GetStockObject(NULL_BRUSH);
}

void
TScrnSavWindow::SetupWindow()
{
  TFrameWindow::SetupWindow();
  GetCursorPos(PrevPt);
  TRect r;
  ::GetWindowRect(GetDesktopWindow(), &r);
  MoveWindow(r, TRUE);
}

void
TScrnSavWindow::EvMouseMove(UINT, TPoint& point)
{
  if (point != PrevPt)
	 PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvLButtonDown(UINT, TPoint&)
{
  PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvRButtonDown(UINT, TPoint&)
{
  PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvMButtonDown(UINT, TPoint&)
{
  PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvActivate(UINT active, BOOL, HWND)
{
  if (!active)
	 PostMessage(WM_CLOSE);
}

#if defined(__WIN32__)
  void TScrnSavWindow::EvActivateApp(BOOL active, HANDLE)
#else
  void TScrnSavWindow::EvActivateApp(BOOL active, HTASK)
#endif
{
  if (!active)
	 PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvKeyDown(UINT, UINT, UINT)
{
  PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvSysKeyDown(UINT, UINT, UINT)
{
  PostMessage(WM_CLOSE);
}

void
TScrnSavWindow::EvSysCommand(UINT cmdType, TPoint&)
{
  if ((cmdType & 0xFFF0) != SC_SCREENSAVE)
	 DefaultProcessing();
}

int
TScrnSavApp::Run()
{
  if (strcmp(lpCmdLine, "/c") == 0 || strcmp(lpCmdLine, "-c") == 0|| strcmp(lpCmdLine, "-C") == 0|| strcmp(lpCmdLine, "/C") == 0) {
	 Configuring = TRUE;
	 InitConfigDialog();

	 //
	 // Get the desktop control panel applet's window handle and make a
	 // TWindow out of it.
	 //
	 HWND deskAppletHWnd = ::FindWindow(WC_DIALOG, "Desktop");
	 TWindow* deskAppletWnd = 0;
	 if (deskAppletHWnd)
		deskAppletWnd = new TWindow(deskAppletHWnd);

	 //
	 // Set our config dialog to have the applet window as its parent if
	 // available
	 //
	 if (deskAppletWnd)
		ConfigureDialog->SetParent(deskAppletWnd);
	 ConfigureDialog->Execute();
	 delete ConfigureDialog;

	 //
	 // When our alias is destructed, it remove its thunk, & restores old proc
	 //
	 delete deskAppletWnd;
	 return Status;

  } else {
	 Configuring = FALSE;
	 return TApplication::Run();
  }
}

void
TScrnSavApp::InitMainWindow()
{
  Configuring = FALSE;
  InitScrnSavWindow();
  if (ScrnSavWnd)
	 MainWindow = ScrnSavWnd;
  LastTime = GetCurrentTime();
}

void
TScrnSavApp::InitScrnSavWindow()
{
  ScrnSavWnd = new TScrnSavWindow(0, 0, 0);
}

BOOL
TScrnSavApp::IdleAction(long)
{
  if (!Configuring) {
	 uint32 diffTime = GetCurrentTime() - LastTime;
	 if (diffTime > 10 || diffTime > 50) {
		ScrnSavWnd->AnimateScreen();
		LastTime = GetCurrentTime();
	 }
	 return TRUE;
  }
  return FALSE;
}


class TMyScrnSavWindow : public TScrnSavWindow {
  public:
	 TMyScrnSavWindow(TWindow* parent, const char* title, TModule* = 0);

  protected:
	 char far* GetClassName() {return(AppName);}
	 void  GetWindowClass(WNDCLASS& wndClass);

	 virtual void  AnimateScreen();

  private:
	 TBitmap*    Live;
	 TBitmap*    Dead_Grnde;
	 TBitmap*    Dead_Mchgun;
	 TBitmap*    Dead_Explde;
	 TBitmap*    Black;

};

TMyScrnSavWindow::TMyScrnSavWindow(TWindow* parent, const char* title,
											  TModule* module)
  : TWindow(parent, title, module),
	 TScrnSavWindow(parent, title, module)
{
HINSTANCE inst = *GetModule();
Live = new TBitmap(inst, "Live");
Dead_Grnde = new TBitmap(inst, "Dead_Grnde");
Dead_Mchgun = new TBitmap(inst, "Dead_Mchgun");
Dead_Explde = new TBitmap(inst, "Dead_Explde");
Black = new TBitmap(inst, "Black");
GetPrivateProfileString(AppName,"Animation","1",Animationa,5,"Control.ini");
GetPrivateProfileString(AppName,"Sound","1",Sounda,5,"Control.ini");
Animationi = atoi(Animationa);
Soundi = atoi(Sounda);

}

void
TMyScrnSavWindow::GetWindowClass(WNDCLASS& wndClass)
{
  TScrnSavWindow::GetWindowClass(wndClass);
  wndClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
}

void
TMyScrnSavWindow::AnimateScreen()
{
  TClientDC dc(*this);
  TMemoryDC memDC(dc);
  int i;
  int temp;
  i = random(Numholes);
  if(HoleInfo[i].alive == 0) {
	memDC.SelectObject(*Live);
	dc.BitBlt(Holes[i].x,Holes[i].y, Live->Width(), Live->Height(), memDC, 0, 0, SRCCOPY);
	HoleInfo[i].livetme = 0;
	HoleInfo[i].alive = 1;
  }else if(HoleInfo[i].alive == 2 &&  HoleInfo[i].deadtme >= 15) {
	memDC.SelectObject(*Black);
	dc.BitBlt(Holes[i].x,Holes[i].y, Black->Width(), Black->Height(), memDC, 0, 0, SRCCOPY);
	HoleInfo[i].alive = 0;
  }else if(HoleInfo[i].alive == 1 && HoleInfo[i].livetme >= 15){
	if(Animationi == 1){
	if(Soundi ==1)
	sndPlaySound("Missle.Wav",SND_ASYNC);
	memDC.SelectObject(*Dead_Explde);
	dc.BitBlt(Holes[i].x,Holes[i].y, Dead_Explde->Width(), Dead_Explde->Height(), memDC, 0, 0, SRCCOPY);
	}
	if(Animationi == 2){
	if(Soundi ==1)
	sndPlaySound("Mchgun.Wav",SND_ASYNC);
	memDC.SelectObject(*Dead_Mchgun);
	dc.BitBlt(Holes[i].x,Holes[i].y, Dead_Mchgun->Width(), Dead_Mchgun->Height(), memDC, 0, 0, SRCCOPY);
	}
	if(Animationi == 3){
	if(Soundi ==1)
	sndPlaySound("Zap.Wav",SND_ASYNC);
	memDC.SelectObject(*Dead_Grnde);
	dc.BitBlt(Holes[i].x,Holes[i].y, Dead_Grnde->Width(), Dead_Grnde->Height(), memDC, 0, 0, SRCCOPY);
	}
	if(Animationi == 4){
	temp = random(3) +1;
		if(temp == 1){
	if(Soundi ==1)
	sndPlaySound("Missle.Wav",SND_ASYNC);
	memDC.SelectObject(*Dead_Explde);
	dc.BitBlt(Holes[i].x,Holes[i].y, Dead_Explde->Width(), Dead_Explde->Height(), memDC, 0, 0, SRCCOPY);
	}
	if(temp == 2){
	if(Soundi ==1)
	sndPlaySound("Mchgun.Wav",SND_ASYNC);
	memDC.SelectObject(*Dead_Mchgun);
	dc.BitBlt(Holes[i].x,Holes[i].y, Dead_Mchgun->Width(), Dead_Mchgun->Height(), memDC, 0, 0, SRCCOPY);
	}
	if(temp == 3){
	if(Soundi ==1)
	sndPlaySound("Zap.Wav",SND_ASYNC);
	memDC.SelectObject(*Dead_Grnde);
	dc.BitBlt(Holes[i].x,Holes[i].y, Dead_Grnde->Width(), Dead_Grnde->Height(), memDC, 0, 0, SRCCOPY);
	}
	}
	HoleInfo[i].alive =2;
	HoleInfo[i].deadtme = 0;
  }else {
	for(i = 0;i<Numholes;i++) {
	 if(HoleInfo[i].alive != 0){
		if(HoleInfo[i].alive == 1)
			HoleInfo[i].livetme++;
		if(HoleInfo[i].alive == 2)
			HoleInfo[i].deadtme++;
	 }
	}
  }
}
//----------------------------------------------------------------------------

class TScrnSavDlg : public TDialog {
  public:
	 TScrnSavDlg(TWindow* parent, const char* name, TModule* module)
		: TDialog(parent, name, module) {}

	 void SetupWindow();
	 void CloseWindow(int retValue);

  DECLARE_RESPONSE_TABLE(TScrnSavDlg);
};

DEFINE_RESPONSE_TABLE1(TScrnSavDlg, TDialog)
  EV_COMMAND(IDCANCEL, CmCancel),
END_RESPONSE_TABLE;

void
TScrnSavDlg::SetupWindow()
{
	GetPrivateProfileString(AppName,"Animation","1",Animationa,5,"Control.ini");
	GetPrivateProfileString(AppName,"Sound","1",Sounda,5,"Control.ini");
	Animationi = atoi(Animationa);
	Soundi = atoi(Sounda);
	if(Animationi == 1)
		CheckDlgButton(121,1);
	else if(Animationi == 2)
		CheckDlgButton(122,1);
	else if(Animationi == 3)
		CheckDlgButton(123,1);
	else if(Animationi == 4)
		CheckDlgButton(124,1);
	else if(Animationi != 1 && Animationi != 2 && Animationi != 3 && Animationi != 4){
		CheckDlgButton(121,1);
		Animationi = 1;
	}
	if(Soundi == 1)
		CheckDlgButton(130,1);
}

void
TScrnSavDlg::CloseWindow(int retValue)
{
	int a,b,c,d;
	a = IsDlgButtonChecked(121);
	b = IsDlgButtonChecked(122);
	c = IsDlgButtonChecked(123);
	d = IsDlgButtonChecked(124);
	if(a == 1 && b == 0 && c == 0 && d == 0)
		Animationi = 1;
	if(a == 0 && b == 1 && c == 0 && d == 0)
		Animationi = 2;
	if(a == 0 && b == 0 && c == 1 && d == 0)
		Animationi = 3;
	if(a == 0 && b == 0 && c == 0 && d == 1)
		Animationi = 4;
	Soundi = IsDlgButtonChecked(130);
	itoa(Animationi,Animationa,5);
	itoa(Soundi,Sounda,5);
	WritePrivateProfileString(AppName,"Animation",Animationa,"Control.ini");
	WritePrivateProfileString(AppName,"Sound",Sounda,"Control.ini");
	TDialog::CloseWindow(retValue);
}

//----------------------------------------------------------------------------

class TMyScrnSavApp : public TScrnSavApp {
  public:
	 TMyScrnSavApp(char far* name) : TScrnSavApp(name) {
	 }

	 // Override TScrnSavApp's virtual functions
	 //
	 void  InitScrnSavWindow();
	 void  InitConfigDialog();
};

void
TMyScrnSavApp::InitScrnSavWindow()
{
  ScrnSavWnd = new TMyScrnSavWindow(0, AppName);
}

void
TMyScrnSavApp::InitConfigDialog()
{
  ConfigureDialog = new TScrnSavDlg(0, "IDD_CONFIGURE", this);
}

int
OwlMain(int /*argc*/, char* /*argv*/ [])
{
  return TMyScrnSavApp(AppName).Run();
}
